> This page is for API Reference.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://contentful-staging.ferndocs.com/developers/docs/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://contentful-staging.ferndocs.com/developers/docs/_mcp/server.

# Create a new component type

POST https://api.contentful.com/spaces/{spaceId}/environments/{environmentId}/component_types
Content-Type: application/json

Reference: https://contentful-staging.ferndocs.com/developers/docs/references/experiences-management-api/component-types/create-component-type

## Authentication

- `Authorization` header (bearer token, required) — Contentful Management API token

## Request

### Path parameters

- `spaceId` (string, required)
- `environmentId` (string, required)

### Query parameters

- `access_token` (string, optional)

### Body (application/json)

This endpoint expects an object.

- `name` (string, required)
- `description` (string, required)
- `viewports` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaViewportsItems, required)
- `contentProperties` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaContentPropertiesItems, required)
- `designProperties` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDesignPropertiesItems, required)
- `dimensionKeyMap` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDimensionKeyMap, required)
- `componentTree` (list of delete__spaces__spaceId__environments__environmentId__component_types__id__published_10_200___schema2, optional)
- `slots` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaSlotsItems, optional)
- `metadata` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaMetadata, optional)
- `dataAssemblies` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDataAssembliesItems, optional)
- `source` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaSource, optional, nullable)

## Response

### 201

201

- `sys` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSys, required)
- `name` (string, required)
- `description` (string, required)
- `viewports` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaViewportsItems, required)
- `contentProperties` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaContentPropertiesItems, required)
- `designProperties` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDesignPropertiesItems, required)
- `dimensionKeyMap` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDimensionKeyMap, required)
- `componentTree` (list of delete__spaces__spaceId__environments__environmentId__component_types__id__published_10_200___schema2, optional)
- `slots` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSlotsItems, optional)
- `metadata` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaMetadata, optional)
- `dataAssemblies` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDataAssembliesItems, optional)
- `source` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSource, optional)

## Errors

### 400 Bad Request Error

400

- `sys` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSys, required)
- `message` (string, optional)
- `requestId` (string, optional)
- `details` (any, optional)
- `i18nContext` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaI18NContext, optional)

### 401 Unauthorized Error

401

- `sys` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSys, required)
- `message` (string, optional)
- `requestId` (string, optional)
- `details` (any, optional)
- `i18nContext` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaI18NContext, optional)

### 403 Forbidden Error

403

- `sys` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSys, required)
- `message` (string, optional)
- `requestId` (string, optional)
- `details` (any, optional)
- `i18nContext` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaI18NContext, optional)

### 404 Not Found Error

404

- `sys` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSys, required)
- `message` (string, optional)
- `requestId` (string, optional)
- `details` (any, optional)
- `i18nContext` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaI18NContext, optional)

### 409 Conflict Error

409

- `sys` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSys, required)
- `message` (string, optional)
- `requestId` (string, optional)
- `details` (any, optional)
- `i18nContext` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaI18NContext, optional)

### 422 Unprocessable Entity Error

422

- `sys` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSys, required)
- `message` (string, optional)
- `requestId` (string, optional)
- `details` (any, optional)
- `i18nContext` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaI18NContext, optional)

### 500 Internal Server Error

500

- `sys` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSys, required)
- `message` (string, optional)
- `requestId` (string, optional)
- `details` (any, optional)
- `i18nContext` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaI18NContext, optional)

## Types

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaViewportsItems

- `id` (string, required)
- `query` (string, required)
- `displayName` (string, required)
- `previewSize` (string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaContentPropertiesItems

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDesignPropertiesItems

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDimensionKeyMap

- `designProperties` (map from string to map from string to string, required)

### delete__spaces__spaceId__environments__environmentId__component_types__id__published_10_200___schema2

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaSlotsItems

- `id` (string, required)
- `name` (string, required)
- `required` (boolean, required)
- `validations` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaSlotsItemsValidationsItems, required)
- `allowedResources` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaSlotsItemsAllowedResourcesItems, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaMetadata

- `tags` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaMetadataTagsItems, optional)
- `concepts` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaMetadataConceptsItems, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDataAssembliesItems

- `sys` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDataAssembliesItemsSys, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaSource

- `sys` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaSourceSys, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSys

- `id` (string, required)
- `type` ("Error", required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaViewportsItems

- `id` (string, required)
- `query` (string, required)
- `displayName` (string, required)
- `previewSize` (string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaContentPropertiesItems

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDesignPropertiesItems

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDimensionKeyMap

- `designProperties` (map from string to map from string to string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSlotsItems

- `id` (string, required)
- `name` (string, required)
- `required` (boolean, required)
- `validations` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSlotsItemsValidationsItems, required)
- `allowedResources` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSlotsItemsAllowedResourcesItems, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaMetadata

- `tags` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaMetadataTagsItems, optional)
- `concepts` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaMetadataConceptsItems, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDataAssembliesItems

- `sys` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDataAssembliesItemsSys, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSource

- `sys` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSourceSys, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaI18NContext

- `code` (string, required)
- `pluralCount` (double, optional)
- `parameters` (map from string to SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaI18NContextParameters, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaContentPropertiesItems0

- `name` (string, required)
- `required` (boolean, required)
- `type` (enum, required)
  - Allowed values: `String`, `Number`, `Integer`, `Boolean`
- `id` (string, required)
- `defaultValue` (any, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaContentPropertiesItems1

- `name` (string, required)
- `required` (boolean, required)
- `type` ("RichText", required)
- `id` (string, required)
- `defaultValue` (any, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaContentPropertiesItems2

- `name` (string, required)
- `required` (boolean, required)
- `type` ("Array", required)
- `items` (any, required)
- `id` (string, required)
- `defaultValue` (any, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaContentPropertiesItems3

- `name` (string, required)
- `required` (boolean, required)
- `type` ("Record", required)
- `fields` (map from string to post__spaces__spaceId__environments__environmentId__component_types_5_body___schema1, required)
- `id` (string, required)
- `defaultValue` (any, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaContentPropertiesItems4

- `name` (string, required)
- `required` (boolean, required)
- `type` ("TypeRef", required)
- `ref` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaContentPropertiesItemsOneOf4Ref, required)
- `id` (string, required)
- `defaultValue` (any, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaContentPropertiesItems5

- `name` (string, required)
- `required` (boolean, required)
- `type` ("Literal", required)
- `value` (any, required)
- `valueType` (post__spaces__spaceId__environments__environmentId__component_types_5_body___schema1, required)
- `id` (string, required)
- `defaultValue` (any, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaContentPropertiesItems6

- `name` (string, required)
- `required` (boolean, required)
- `type` ("DiscriminatedUnion", required)
- `discriminator` (string, required)
- `members` (list of post__spaces__spaceId__environments__environmentId__component_types_5_body___schema1, required)
- `id` (string, required)
- `defaultValue` (any, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDesignPropertiesItems0

- `id` (string, required)
- `name` (string, required)
- `type` ("String", required)
- `description` (string, optional)
- `fallbackValue` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDesignPropertiesItemsOneOf0FallbackValue, optional)
- `validations` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDesignPropertiesItemsOneOf0ValidationsItems, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDesignPropertiesItems1

- `id` (string, required)
- `name` (string, required)
- `type` ("Boolean", required)
- `description` (string, optional)
- `fallbackValue` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDesignPropertiesItemsOneOf1FallbackValue, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDesignPropertiesItems2

- `id` (string, required)
- `name` (string, required)
- `type` (enum, required)
  - Allowed values: `DTCG.Color`, `DTCG.Dimension`, `DTCG.FontFamily`, `DTCG.FontWeight`, `DTCG.Duration`, `DTCG.CubicBezier`, `DTCG.Number`, `DTCG.StrokeStyle`, `DTCG.Border`, `DTCG.Transition`, `DTCG.Shadow`, `DTCG.Gradient`, `DTCG.Typography`
- `description` (string, optional)
- `fallbackValue` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDesignPropertiesItemsOneOf2FallbackValue, optional)
- `allowedResources` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDesignPropertiesItemsOneOf2AllowedResourcesItems, optional)

### DeleteSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesIdPublished10200Schema20

- `id` (string, required)
- `nodeType` ("Component", required)
- `componentType` (DeleteSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesIdPublished10200Schema2OneOf0ComponentType, required)
- `contentProperties` (DeleteSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesIdPublished10200Schema2OneOf0ContentProperties, required)
- `designProperties` (map from string to DeleteSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesIdPublished10200Schema2OneOf0DesignProperties, required)
- `slots` (map from string to list of delete__spaces__spaceId__environments__environmentId__component_types__id__published_10_200___schema2, required)
- `name` (string, optional)

### DeleteSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesIdPublished10200Schema21

- `id` (string, required)
- `nodeType` ("Fragment", required)
- `fragment` (DeleteSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesIdPublished10200Schema2OneOf1Fragment, required)
- `name` (string, optional)

### DeleteSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesIdPublished10200Schema22

- `id` (string, required)
- `nodeType` ("Slot", required)
- `slotId` (string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaSlotsItemsValidationsItems

- `size` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaSlotsItemsValidationsItemsSize, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaSlotsItemsAllowedResourcesItems

- `type` ("Contentful:ComponentType", required)
- `source` (string, required)
- `allowedTypes` (list of string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaMetadataTagsItems

- `sys` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaMetadataTagsItemsSys, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaMetadataConceptsItems

- `sys` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaMetadataConceptsItemsSys, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDataAssembliesItemsSys

- `type` ("ResourceLink", required)
- `linkType` ("Contentful:DataAssembly", required)
- `urn` (string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaSourceSys

- `type` ("ResourceLink", required)
- `linkType` ("Contentful:DesignSystemSource", required)
- `urn` (string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaContentPropertiesItems0

- `name` (string, required)
- `required` (boolean, required)
- `type` (enum, required)
  - Allowed values: `String`, `Number`, `Integer`, `Boolean`
- `id` (string, required)
- `defaultValue` (any, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaContentPropertiesItems1

- `name` (string, required)
- `required` (boolean, required)
- `type` ("RichText", required)
- `id` (string, required)
- `defaultValue` (any, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaContentPropertiesItems2

- `name` (string, required)
- `required` (boolean, required)
- `type` ("Array", required)
- `items` (any, required)
- `id` (string, required)
- `defaultValue` (any, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaContentPropertiesItems3

- `name` (string, required)
- `required` (boolean, required)
- `type` ("Record", required)
- `fields` (map from string to post__spaces__spaceId__environments__environmentId__component_types_5_201___schema1, required)
- `id` (string, required)
- `defaultValue` (any, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaContentPropertiesItems4

- `name` (string, required)
- `required` (boolean, required)
- `type` ("TypeRef", required)
- `ref` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaContentPropertiesItemsOneOf4Ref, required)
- `id` (string, required)
- `defaultValue` (any, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaContentPropertiesItems5

- `name` (string, required)
- `required` (boolean, required)
- `type` ("Literal", required)
- `value` (any, required)
- `valueType` (post__spaces__spaceId__environments__environmentId__component_types_5_201___schema1, required)
- `id` (string, required)
- `defaultValue` (any, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaContentPropertiesItems6

- `name` (string, required)
- `required` (boolean, required)
- `type` ("DiscriminatedUnion", required)
- `discriminator` (string, required)
- `members` (list of post__spaces__spaceId__environments__environmentId__component_types_5_201___schema1, required)
- `id` (string, required)
- `defaultValue` (any, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDesignPropertiesItems0

- `id` (string, required)
- `name` (string, required)
- `type` ("String", required)
- `description` (string, optional)
- `fallbackValue` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDesignPropertiesItemsOneOf0FallbackValue, optional)
- `validations` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDesignPropertiesItemsOneOf0ValidationsItems, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDesignPropertiesItems1

- `id` (string, required)
- `name` (string, required)
- `type` ("Boolean", required)
- `description` (string, optional)
- `fallbackValue` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDesignPropertiesItemsOneOf1FallbackValue, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDesignPropertiesItems2

- `id` (string, required)
- `name` (string, required)
- `type` (enum, required)
  - Allowed values: `DTCG.Color`, `DTCG.Dimension`, `DTCG.FontFamily`, `DTCG.FontWeight`, `DTCG.Duration`, `DTCG.CubicBezier`, `DTCG.Number`, `DTCG.StrokeStyle`, `DTCG.Border`, `DTCG.Transition`, `DTCG.Shadow`, `DTCG.Gradient`, `DTCG.Typography`
- `description` (string, optional)
- `fallbackValue` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDesignPropertiesItemsOneOf2FallbackValue, optional)
- `allowedResources` (list of SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDesignPropertiesItemsOneOf2AllowedResourcesItems, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSlotsItemsValidationsItems

- `size` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSlotsItemsValidationsItemsSize, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSlotsItemsAllowedResourcesItems

- `type` ("Contentful:ComponentType", required)
- `source` (string, required)
- `allowedTypes` (list of string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaMetadataTagsItems

- `sys` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaMetadataTagsItemsSys, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaMetadataConceptsItems

- `sys` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaMetadataConceptsItemsSys, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDataAssembliesItemsSys

- `type` ("ResourceLink", required)
- `linkType` ("Contentful:DataAssembly", required)
- `urn` (string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSourceSys

- `type` ("ResourceLink", required)
- `linkType` ("Contentful:DesignSystemSource", required)
- `urn` (string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaI18NContextParameters

### post__spaces__spaceId__environments__environmentId__component_types_5_body___schema1

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaContentPropertiesItemsOneOf4Ref

- `sys` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaContentPropertiesItemsOneOf4RefSys, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDesignPropertiesItemsOneOf0FallbackValue

- `type` ("ManualDesignValue", required)
- `value` (string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDesignPropertiesItemsOneOf0ValidationsItems

- `regexp` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDesignPropertiesItemsOneOf0ValidationsItemsRegexp, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDesignPropertiesItemsOneOf1FallbackValue

- `type` ("ManualDesignValue", required)
- `value` (boolean, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDesignPropertiesItemsOneOf2FallbackValue

- `type` ("DesignToken", required)
- `value` (string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDesignPropertiesItemsOneOf2AllowedResourcesItems

- `type` ("DesignToken", required)
- `value` (string, required)
- `name` (string, optional)

### DeleteSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesIdPublished10200Schema2OneOf0ComponentType

- `sys` (DeleteSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesIdPublished10200Schema2OneOf0ComponentTypeSys, required)

### DeleteSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesIdPublished10200Schema2OneOf0ContentProperties

### DeleteSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesIdPublished10200Schema2OneOf0DesignProperties

### DeleteSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesIdPublished10200Schema2OneOf1Fragment

- `sys` (DeleteSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesIdPublished10200Schema2OneOf1FragmentSys, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaSlotsItemsValidationsItemsSize

- `min` (double, optional)
- `max` (double, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaMetadataTagsItemsSys

- `type` ("Link", required)
- `linkType` ("Tag", required)
- `id` (string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaMetadataConceptsItemsSys

- `type` ("Link", required)
- `linkType` ("TaxonomyConcept", required)
- `id` (string, required)

### post__spaces__spaceId__environments__environmentId__component_types_5_201___schema1

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaContentPropertiesItemsOneOf4Ref

- `sys` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaContentPropertiesItemsOneOf4RefSys, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDesignPropertiesItemsOneOf0FallbackValue

- `type` ("ManualDesignValue", required)
- `value` (string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDesignPropertiesItemsOneOf0ValidationsItems

- `regexp` (SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDesignPropertiesItemsOneOf0ValidationsItemsRegexp, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDesignPropertiesItemsOneOf1FallbackValue

- `type` ("ManualDesignValue", required)
- `value` (boolean, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDesignPropertiesItemsOneOf2FallbackValue

- `type` ("DesignToken", required)
- `value` (string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDesignPropertiesItemsOneOf2AllowedResourcesItems

- `type` ("DesignToken", required)
- `value` (string, required)
- `name` (string, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaSlotsItemsValidationsItemsSize

- `min` (double, optional)
- `max` (double, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaMetadataTagsItemsSys

- `type` ("Link", required)
- `linkType` ("Tag", required)
- `id` (string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaMetadataConceptsItemsSys

- `type` ("Link", required)
- `linkType` ("TaxonomyConcept", required)
- `id` (string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaI18NContextParameters0

- `type` ("string", required)
- `value` (string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaI18NContextParameters1

- `type` ("number", required)
- `value` (double, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaI18NContextParameters2

- `type` ("date", required)
- `value` (string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaI18NContextParameters3

- `type` ("array.string", required)
- `value` (list of string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaI18NContextParameters4

- `type` ("array.number", required)
- `value` (list of double, required)

### PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5BodySchema10

- `type` (enum, required)
  - Allowed values: `String`, `Number`, `Integer`, `Boolean`
- `name` (string, optional)
- `required` (boolean, optional)

### PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5BodySchema11

- `type` ("RichText", required)
- `name` (string, optional)
- `required` (boolean, optional)

### PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5BodySchema12

- `type` ("Array", required)
- `items` (any, required)
- `name` (string, optional)
- `required` (boolean, optional)

### PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5BodySchema13

- `type` ("Record", required)
- `fields` (map from string to post__spaces__spaceId__environments__environmentId__component_types_5_body___schema1, required)
- `name` (string, optional)
- `required` (boolean, optional)

### PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5BodySchema14

- `type` ("TypeRef", required)
- `ref` (PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5BodySchema1OneOf4Ref, required)
- `name` (string, optional)
- `required` (boolean, optional)

### PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5BodySchema15

- `type` ("Literal", required)
- `value` (any, required)
- `valueType` (post__spaces__spaceId__environments__environmentId__component_types_5_body___schema1, required)
- `name` (string, optional)
- `required` (boolean, optional)

### PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5BodySchema16

- `type` ("DiscriminatedUnion", required)
- `discriminator` (string, required)
- `members` (list of post__spaces__spaceId__environments__environmentId__component_types_5_body___schema1, required)
- `name` (string, optional)
- `required` (boolean, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaContentPropertiesItemsOneOf4RefSys

- `type` ("ResourceLink", required)
- `linkType` (string, required)
- `urn` (string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostRequestBodyContentApplicationJsonSchemaDesignPropertiesItemsOneOf0ValidationsItemsRegexp

- `pattern` (string, required)

### DeleteSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesIdPublished10200Schema2OneOf0ComponentTypeSys

- `type` ("ResourceLink", required)
- `linkType` ("Contentful:ComponentType", required)
- `urn` (string, required)

### DeleteSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesIdPublished10200Schema2OneOf1FragmentSys

- `type` ("ResourceLink", required)
- `linkType` ("Contentful:Fragment", required)
- `urn` (string, required)

### PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5201Schema10

- `type` (enum, required)
  - Allowed values: `String`, `Number`, `Integer`, `Boolean`
- `name` (string, optional)
- `required` (boolean, optional)

### PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5201Schema11

- `type` ("RichText", required)
- `name` (string, optional)
- `required` (boolean, optional)

### PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5201Schema12

- `type` ("Array", required)
- `items` (any, required)
- `name` (string, optional)
- `required` (boolean, optional)

### PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5201Schema13

- `type` ("Record", required)
- `fields` (map from string to post__spaces__spaceId__environments__environmentId__component_types_5_201___schema1, required)
- `name` (string, optional)
- `required` (boolean, optional)

### PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5201Schema14

- `type` ("TypeRef", required)
- `ref` (PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5201Schema1OneOf4Ref, required)
- `name` (string, optional)
- `required` (boolean, optional)

### PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5201Schema15

- `type` ("Literal", required)
- `value` (any, required)
- `valueType` (post__spaces__spaceId__environments__environmentId__component_types_5_201___schema1, required)
- `name` (string, optional)
- `required` (boolean, optional)

### PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5201Schema16

- `type` ("DiscriminatedUnion", required)
- `discriminator` (string, required)
- `members` (list of post__spaces__spaceId__environments__environmentId__component_types_5_201___schema1, required)
- `name` (string, optional)
- `required` (boolean, optional)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaContentPropertiesItemsOneOf4RefSys

- `type` ("ResourceLink", required)
- `linkType` (string, required)
- `urn` (string, required)

### SpacesSpaceIdEnvironmentsEnvironmentIdComponentTypesPostResponsesContentApplicationJsonSchemaDesignPropertiesItemsOneOf0ValidationsItemsRegexp

- `pattern` (string, required)

### PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5BodySchema1OneOf4Ref

- `sys` (PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5BodySchema1OneOf4RefSys, required)

### PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5201Schema1OneOf4Ref

- `sys` (PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5201Schema1OneOf4RefSys, required)

### PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5BodySchema1OneOf4RefSys

- `type` ("ResourceLink", required)
- `linkType` (string, required)
- `urn` (string, required)

### PostSpacesSpaceIdEnvironmentsEnvironmentIdComponentTypes5201Schema1OneOf4RefSys

- `type` ("ResourceLink", required)
- `linkType` (string, required)
- `urn` (string, required)

## Examples

**Request**

```json
{
  "name": "string",
  "description": "string",
  "viewports": [
    {
      "id": "string",
      "query": "string",
      "displayName": "string",
      "previewSize": "string"
    }
  ],
  "contentProperties": [
    {
      "name": "string",
      "required": true,
      "type": "String",
      "id": "string"
    }
  ],
  "designProperties": [
    {
      "id": "string",
      "name": "string",
      "type": "string"
    }
  ],
  "dimensionKeyMap": {
    "designProperties": {}
  }
}
```

**Response**

```json
{
  "sys": {
    "id": "string",
    "type": "string",
    "space": {
      "sys": {
        "type": "string",
        "linkType": "string",
        "id": "string"
      }
    },
    "environment": {
      "sys": {
        "type": "string",
        "linkType": "string",
        "id": "string"
      }
    },
    "version": 1.1,
    "fieldStatus": {},
    "publishedAt": "string",
    "publishedVersion": 1.1,
    "publishedCounter": 1.1,
    "firstPublishedAt": "string",
    "publishedBy": {
      "sys": {
        "type": "string",
        "linkType": "User",
        "id": "string"
      }
    },
    "variant": "string",
    "variantType": "string",
    "variantDimension": "string",
    "createdAt": "string",
    "createdBy": {
      "sys": {
        "type": "string",
        "linkType": "string",
        "id": "string"
      }
    },
    "updatedAt": "string",
    "updatedBy": {
      "sys": {
        "type": "string",
        "linkType": "string",
        "id": "string"
      }
    }
  },
  "name": "string",
  "description": "string",
  "viewports": [
    {
      "id": "string",
      "query": "string",
      "displayName": "string",
      "previewSize": "string"
    }
  ],
  "contentProperties": [
    {
      "name": "string",
      "required": true,
      "type": "String",
      "id": "string"
    }
  ],
  "designProperties": [
    {
      "id": "string",
      "name": "string",
      "description": "string",
      "type": "string",
      "fallbackValue": {
        "type": "string",
        "value": "string"
      },
      "validations": [
        {
          "regexp": {
            "pattern": "string"
          }
        }
      ]
    }
  ],
  "dimensionKeyMap": {
    "designProperties": {}
  },
  "componentTree": [
    {
      "id": "string",
      "nodeType": "string",
      "componentType": {
        "sys": {
          "type": "string",
          "linkType": "string",
          "urn": "string"
        }
      },
      "contentProperties": {},
      "designProperties": {},
      "slots": {},
      "name": "string"
    }
  ],
  "slots": [
    {
      "id": "string",
      "name": "string",
      "required": true,
      "validations": [
        {
          "size": {
            "min": 1.1,
            "max": 1.1
          }
        }
      ],
      "allowedResources": [
        {
          "type": "string",
          "source": "string",
          "allowedTypes": [
            "string"
          ]
        }
      ]
    }
  ],
  "metadata": {
    "tags": [
      {
        "sys": {
          "type": "string",
          "linkType": "string",
          "id": "string"
        }
      }
    ],
    "concepts": [
      {
        "sys": {
          "type": "string",
          "linkType": "string",
          "id": "string"
        }
      }
    ]
  },
  "dataAssemblies": [
    {
      "sys": {
        "type": "string",
        "linkType": "string",
        "urn": "string"
      }
    }
  ],
  "source": {
    "sys": {
      "type": "string",
      "linkType": "string",
      "urn": "string"
    }
  }
}
```